src/applications/urls.py
from django.urls import path

from . import views

urlpatterns = [
    path("", views.ApplicationListView.as_view(), name="application_list"),
    path(
        "rejected/",
        views.RejectedApplicationListView.as_view(),
        name="application_list_rejected",
    ),
    path(
        "<int:volunteer_id>/",
        views.ApplicationUpdateView.as_view(),
        name="application_update",
    ),  # needs to be updated, it's called with the volunteer id now
    path(
        "<int:volunteer_id>/reject/",
        views.application_reject,
        name="application_reject",
    ),
    path(
        "<int:volunteer_id>/accept/",
        views.accept_application,
        name="application_accept",
    ),
    path(
        "<int:volunteer_id>/add_comment/",
        views.add_comment,
        name="application_add_comment",
    ),
    path(
        "<int:volunteer_id>/decide_position/",
        views.decide_position,
        name="application_decide_position",
    ),
    path(
        "<int:volunteer_id>/update_additional_positions/",
        views.update_additional_positions,
        name="application_update_additional_positions",
    ),
]

src/operations/urls.py
from django.urls import path

from operations import views

urlpatterns = [
    path("", views.CurrentOperationsListView.as_view(), name="operation_list"),
    path(
        "past_operations/",
        views.PastOperationsListView.as_view(),
        name="past_operation_list",
    ),
    path(
        "<int:pk>/",
        views.operation,
        name="operation",
    ),
    path(
        "line/<int:line_pk>/delete-dialog/",
        views.OperationLineDeleteView.as_view(),
        name="operationline_confirm_delete",
    ),
    path(
        "operation_line/<int:pk>/",
        views.operation_line,
        name="operation_line",
    ),
    path(
        "operation_line/<int:pk>/select_volunteer_dialog/",
        views.operationline_select_volunteer_dialog,
        name="operationline_select_volunteer_dialog",
    ),
]

src/applications/models.py
from __future__ import annotations

from collections.abc import Callable
from datetime import datetime, timezone
from typing import TYPE_CHECKING, ClassVar, Optional

from django.contrib.auth.models import User
from django.db import models
from django.urls import reverse
from django.utils.translation import gettext_lazy as _

from seawatch_registration.models import Position, ShortTextField
from volunteers.models import Volunteer


if TYPE_CHECKING:

    class SarApplicationManager(models.Manager["SarApplication"]):
        def open(self) -> SarApplicationQuerySet: ...
        def closed(self) -> SarApplicationQuerySet: ...
        def undecided(self) -> SarApplicationQuerySet: ...
        def accepted(self) -> SarApplicationQuerySet: ...
        def rejected(self) -> SarApplicationQuerySet: ...


class SarApplicationQuerySet(models.QuerySet["SarApplication"]):
    def open(self) -> SarApplicationQuerySet:
        return self.filter(closed=None)

    def closed(self) -> SarApplicationQuerySet:
        return self.filter(closed__isnull=False)

    def undecided(self) -> SarApplicationQuerySet:
        return self.filter(
            models.Q(decision=SarApplication.Decision.NEW)
            | models.Q(decision=SarApplication.Decision.IN_PROGRESS)
        )

    def accepted(self) -> SarApplicationQuerySet:
        return self.closed().filter(decision=SarApplication.Decision.ACCEPT)

    def rejected(self) -> SarApplicationQuerySet:
        return self.closed().filter(decision=SarApplication.Decision.REJECT)


def now():
    return datetime.now(timezone.utc)


class AlreadyClosedException(Exception):
    pass


class SarApplication(models.Model):
    """A volunteer's application to join sea-watch on a search-and-rescue operation.

    This is position-specific, so if someone applies for multiple positions there will be one
    SarApplication for each one.

    The lifecycle looks like this:
        1. Open
            - Determined by .closed == None
            - .decision does not immediately affect the state
        2.1 Accepted
            - Determined by .closed != None and .decision = ACCEPT
            - Makes the volunteer show up in the volunteer pool and stuff
        2.2 Rejected
            - .closed != None and .decision = REJECT
            - Volunteer shows up in rejected list
            - SarApplication will be auto-deleted after some time
    """

    if TYPE_CHECKING:
        objects: ClassVar[SarApplicationManager]
    objects = SarApplicationQuerySet.as_manager()  # type: ignore
    all_objects: ClassVar[models.Manager[SarApplication]] = models.Manager()

    id = models.AutoField(primary_key=True)

    volunteer = models.ForeignKey(Volunteer, on_delete=models.CASCADE)

    position = models.ForeignKey(Position, on_delete=models.PROTECT)

    class Decision(models.TextChoices):
        NEW = "new", _("New")
        IN_PROGRESS = "in_progress", _("In progress")
        REJECT = "reject", _("Reject")
        ACCEPT = "accept", _("Accept")

    decision = ShortTextField(choices=Decision.choices, default=Decision.NEW)
    get_decision_display: Callable[[], str]  # added by django

    created = models.DateTimeField(default=now)
    closed = models.DateTimeField(null=True)
    by = models.ForeignKey(User, on_delete=models.PROTECT, default=None, null=True)
    time = models.DateTimeField(default=None, null=True)

    def __str__(self) -> str:
        return f"{self.volunteer.name} as {self.position.name}: {self.get_decision_display()}"

    def is_new(self):
        return self.decision == self.Decision.NEW

    def is_in_progress(self):
        return self.decision == self.Decision.IN_PROGRESS

    def is_accepted(self):
        # TODO: with the addition of closed, this name became ambiguous
        return self.decision == self.Decision.ACCEPT

    def is_rejected(self):
        # TODO: with the addition of closed, this name became ambiguous
        return self.decision == self.Decision.REJECT

    def is_closed(self):
        return self.closed is not None

    def get_absolute_url(self):
        return reverse("application_update", kwargs={"volunteer_id": self.volunteer.pk})

    def accept(self):
        if self.is_closed():
            raise AlreadyClosedException()
        self.volunteer.sarprofile_set.create(position=self.position)
        self.decision = SarApplication.Decision.ACCEPT
        self.closed = datetime.now(tz=timezone.utc)
        self.save()

    def reject(self):
        if self.is_closed():
            raise AlreadyClosedException()
        self.decision = SarApplication.Decision.REJECT
        self.closed = datetime.now(tz=timezone.utc)
        self.save()


class Import(models.Model):
    time = models.DateTimeField(default=now)

    @classmethod
    def update_to_now(cls) -> None:
        cls.objects.update_or_create(defaults={"time": datetime.now(timezone.utc)})

    @classmethod
    def get_last_imported(cls) -> Optional[datetime]:
        try:
            return cls.objects.get().time
        except cls.DoesNotExist:
            return None

src/applications/views.py
import json
import logging
from collections.abc import Callable
from datetime import datetime, timezone
from typing import Any
from urllib.parse import urlencode

from django.conf import settings
from django.contrib import messages
from django.contrib.auth.decorators import permission_required
from django.contrib.auth.mixins import PermissionRequiredMixin
from django.contrib.auth.models import User
from django.core.mail import send_mail
from django.db.models import FilteredRelation, Q, QuerySet
from django.http import Http404
from django.http.request import HttpRequest
from django.http.response import (
    HttpResponse,
    HttpResponseBadRequest,
    HttpResponseNotFound,
    HttpResponseRedirect,
    HttpResponseRedirectBase,
)
from django.shortcuts import get_object_or_404
from django.template.response import TemplateResponse
from django.urls import reverse
from django.utils.decorators import method_decorator
from django.utils.translation import gettext as _
from django.views.decorators.http import require_POST
from django.views.generic.edit import UpdateView
from django_tables2 import SingleTableView

from planner_common.feature_flags import features
from seawatch_registration.models import Position
from volunteers.models import Volunteer

from . import forms
from .models import Import, SarApplication
from .tables import OpenApplicationsTable, RejectedApplicationsTable

logger = logging.getLogger(__name__)


def get_position_or_none(key):
    try:
        return Position.objects.get(key=key)
    except Position.DoesNotExist:
        return None


@require_POST
def add_comment(request, volunteer_id):
    volunteer = get_object_or_404(Volunteer, pk=volunteer_id)
    text = request.POST.get("comment")
    if not text:
        return HttpResponseBadRequest('"comment" POST parameter required')

    comment = volunteer.comments.create(
        author=request.user,
        text=text,
    )

    return TemplateResponse(
        request,
        "applications/application_form_add_comment.html",
        {"comment": comment, "volunteer": volunteer},
    )


persisted_get_params_session_key = "ApplicationListView__persisted_flags"


def common_filter_context() -> dict:
    positions_by_group = Position.objects.by_group()
    return {
        "positions_without_group": positions_by_group.pop("", []),
        "positions_with_group": positions_by_group,
    }


persisted_get_params = {"search", "position", "only_ready_to_close", "sort"}


def redirect_based_on_saved_search_if_appropriate(
    request: HttpRequest, current_url_name: str
) -> HttpResponseRedirect | None:
    if not any(k in request.GET for k in persisted_get_params) and (
        session_data := request.session.get(persisted_get_params_session_key)
    ):
        try:
            query = {
                k: session_data[k] for k in persisted_get_params if session_data.get(k)
            }
            # Not sure in which situations the session data would be empty, but lets check and
            # fall through anyhow
            if query:
                return HttpResponseRedirect(
                    f"{reverse(current_url_name)}?{urlencode(query)}"
                )
        except Exception:
            logger.exception(
                f"Failed to retrieve old application list settings from session (data in session: {session_data})"
            )
            del request.session[persisted_get_params_session_key]


def persist_query_parameters(request: HttpRequest) -> None:
    request.session[persisted_get_params_session_key] = {
        k: request.GET.get(k) for k in persisted_get_params
    }


class ApplicationListView(SingleTableView):
    table_class = OpenApplicationsTable
    template_name = "applications/application_list.html"

    search: str | None = None
    position: str | None = None
    only_ready_to_close: bool | None = None
    sort: str | None = None

    def get_queryset(self):
        # Getting this query to work right was a bit of a struggle tbh.
        # It was hard to make sure all the conditions apply to the same SarApplication entry
        qs = Volunteer.objects.annotate(
            application=FilteredRelation(
                "sarapplication",
                condition=Q(
                    # sarapplication__isnull=False,
                    sarapplication__closed=None,
                ),
            )
        ).filter(application__isnull=False)
        if self.position:
            qs = qs.filter(application__position__key=self.position)
        if self.only_ready_to_close:
            qs = qs.exclude(
                application__decision__in=[
                    SarApplication.Decision.NEW,
                    SarApplication.Decision.IN_PROGRESS,
                ],
            )
        if self.search:
            search_without_spaces = self.search.split(" ")
            for word in search_without_spaces:
                qs = qs.filter(
                    Q(first_name__icontains=word) | Q(last_name__icontains=word)
                )

        # Use `qs.query.sql_with_params()` to inspect the query
        return qs.distinct()

    def get_context_data(self, **kwargs):
        ctx = super().get_context_data(**kwargs)
        ctx["last_import"] = Import.get_last_imported()

        ctx = {**ctx, **common_filter_context()}

        ctx["search"] = self.search or ""
        ctx["selected_position"] = get_position_or_none(self.position)
        ctx["only_ready_to_close"] = self.only_ready_to_close
        ctx["sort_filter"] = self.request.GET.get(
            "sort"
        )  # needed to preserve sort after filtering
        return ctx

    @method_decorator(
        permission_required(
            [
                "applications.view_sarapplication",
                "volunteers.view_volunteer",
            ],
            raise_exception=True,
        )
    )
    def get(self, request, *args, **kwargs):
        if redirect := redirect_based_on_saved_search_if_appropriate(
            request, "application_list"
        ):
            return redirect

        self.position = request.GET.get("position")
        self.search = request.GET.get("search")
        self.only_ready_to_close = bool(request.GET.get("only_ready_to_close"))

        persist_query_parameters(request)

        return super().get(request, *args, **kwargs)


class RejectedApplicationListView(SingleTableView):
    table_class = RejectedApplicationsTable
    template_name = "applications/application_list_rejected.html"

    def get_queryset(self) -> QuerySet[Volunteer]:
        qs = Volunteer.objects.annotate(
            application=FilteredRelation(
                "sarapplication",
                condition=Q(
                    sarapplication__closed__isnull=False,
                    sarapplication__decision=SarApplication.Decision.REJECT,
                ),
            )
        ).filter(application__isnull=False)
        if self.position:
            qs = qs.filter(application__position__key=self.position)
        if self.search:
            search_without_spaces = self.search.split(" ")
            for word in search_without_spaces:
                qs = qs.filter(
                    Q(first_name__icontains=word) | Q(last_name__icontains=word)
                )
        return qs.distinct()

    def get_context_data(self, **kwargs: Any) -> dict[str, Any]:
        ctx = super().get_context_data(**kwargs)
        ctx = {**ctx, **common_filter_context()}

        ctx["search"] = self.search or ""
        ctx["selected_position"] = get_position_or_none(self.position)
        ctx["sort_filter"] = self.request.GET.get(
            "sort"
        )  # needed to preserve sort after filtering
        return ctx

    def get(self, request: HttpRequest, *args: Any, **kwargs: Any) -> HttpResponse:
        if redirect := redirect_based_on_saved_search_if_appropriate(
            request, "application_list_rejected"
        ):
            return redirect

        self.position = request.GET.get("position")
        self.search = request.GET.get("search")

        persist_query_parameters(request)

        return super().get(request, *args, **kwargs)


class ApplicationUpdateView(PermissionRequiredMixin, UpdateView):
    """
    Don't let the name fool you, the core object here is a volunteers.models.Volunteer, but
    we're looking at it as an application.
    """

    permission_required = [
        "applications.view_sarapplication",
        "applications.change_sarapplication",
    ]
    form_class = forms.ApplicationForm
    template_name = "applications/application_form.html"

    # This is still None before django.views.generic.edit.BaseUpdateView sets
    # `self.object = self.get_object()` in .get() and .post(), but we declare it as non-None for
    # simplicity
    object: Volunteer

    # Same here, it's not set before get_object is called but we set it for convenience
    old_history_dict: dict[str, Any]

    def get_object(self, queryset=None) -> Volunteer:
        object = get_object_or_404(Volunteer, pk=self.kwargs["volunteer_id"])
        self.old_history_dict = object.to_history_dict()
        return object

    def post(self, *args, **kwargs):
        return super().post(*args, **kwargs)

    def get_context_data(self, **kwargs):
        ctx = super().get_context_data(**kwargs)

        ctx["rejected"] = "rejected" in self.request.GET
        ctx["rejected_positions"] = [
            sa.position
            for sa in SarApplication.objects.filter(
                volunteer=self.object,
                closed__isnull=False,
                decision=SarApplication.Decision.REJECT,
            )
        ]
        ctx["accepted_positions_count"] = SarApplication.objects.filter(
            volunteer=self.object,
            closed__isnull=False,
            decision=SarApplication.Decision.ACCEPT,
        ).count()

        ctx["current_positions_count"] = SarApplication.objects.filter(
            volunteer=self.object,

src/applications/templates/applications/application_accept_dialog.html
{% extends "dialog.html" %}
{% load seawatch_registration_tags applications_tags %}
{% block dialog_attrs %}hx-swap-oob="true"{% endblock %}
{% block modal_id %}planner-modal-accept-application{% endblock %}
{% block header %}Accept Application?{% endblock %}
{% block content %}
  <form method="post"
        id="acceptApplicationForm"
        action='{% url "application_accept" volunteer_id=volunteer.id %}'>
    {% csrf_token %}
    {{ block.super }}
  </form>
{% endblock %}
{% block body %}
  This will create a volunteer profile based on this application.
  <br>
  {{ accept_form }}
{% endblock %}
{% block buttons %}
  <button value="accept" class="button button-primary">
    Create profile as {{ volunteer|positions_with_open_application_and_decision_accept|attr:"name"|method:"lower"|join_comma_and }}
  </button>
{% endblock %}

src/applications/templates/applications/application_decide_position_response.html
{% include "applications/application_form_position_form_last_updated.html" %}
{% with volunteer=sarapplication.volunteer %}
  {% include "applications/application_form_accept_button.html" %}
{% endwith %}

src/applications/templates/applications/application_form.html
{% extends "base.html" %}
{% load i18n applications_tags seawatch_registration_tags tz %}
{% block extra_css %}
  {{ block.super }}
  {{ form.media.css }}
{% endblock %}
{% block content %}
  <h1>
    {{ volunteer.name }}
    <small>Submitted {{ volunteer.applied_at }}</small>
  </h1>
  {% if rejected %}
    <div class="alert alert-warning">
      <p>
        {{ volunteer.first_name }} was rejected for the following positions:
        <ul>
          {% for p in rejected_positions %}<li>{{ p.name }}</li>{% endfor %}
        </ul>
        This page is an overview of that rejection and does not allow any changes.
      </p>
      {% if accepted_positions_count %}
        <p>
          {{ volunteer.first_name }} has been accepted for {{ accepted_positions_count }} position{{ accepted_positions_count|pluralize }},
          <a href="{% url "volunteer_detail" pk=volunteer.id %}">see details.</a>
        </p>
      {% endif %}
      {% if current_positions_count %}
        <p>
          {{ volunteer.first_name }} is currently applying for {{ current_positions_count }} position{{ current_positions_count|pluralize }},
          <a href="{% url "application_update" volunteer_id=volunteer.id %}">see details.</a>
        </p>
      {% endif %}
    </div>
  {% else %}
    {% if rejected_positions %}
      <div class="alert alert-info">
        {{ volunteer.first_name }} was rejected for {{ rejected_positions|length }} position{{ rejected_positions|length|pluralize }},
        <a href="?rejected">see details.</a>
      </div>
    {% endif %}
  {% endif %}
  <section class="application-data planner-grid-of-cards"
           {% if rejected %}inert{% endif %}>
    <form id="application-update-form"
          data-warn-on-leave-if-changed
          method="post"
          novalidate
          autocomplete="off">
      {% csrf_token %}
      {{ form }}
    </form>
  </section>
  <hr>
  <h1 class="alt-color">Sea-Watch Internal</h1>
  <section class="application-internal" {% if rejected %}inert{% endif %}>
    {% include "applications/application_form_accept_some_positions.html" %}
    {% include "applications/application_form_add_comment.html" %}
  </section>
  <div style="display: flex;
              justify-content: end;
              gap: 6px"
       {% if rejected %}inert{% endif %}>
    <button class="button"
            onClick="document.getElementById('planner-modal-reject-application').classList.add('visible')">
      {% if features.keep_rejected_applications %}
        Reject for all positions
      {% else %}
        Delete application
      {% endif %}
    </button>
    {# acceptApplication button is replaced dynamically when deciding positions #}
    {% include "applications/application_form_accept_button.html" %}
  </div>
{% endblock %}
{% block extra_scripts %}
  {{ block.super }}
  {{ form.media.js }}
{% endblock %}
{% block extra_body_content %}
  {% include "applications/application_form_reject_dialog.html" with show_modal_immediately=reject_form_visible %}
{% endblock %}

src/applications/templates/applications/application_form_accept_button.html
{% load i18n seawatch_registration_tags static applications_tags %}
{% with all_decided=volunteer|all_open_sarapplications_decided has_accept=volunteer|has_open_sarapplication_with_decision_accept %}
  <button id="acceptApplication"
          class="button button-primary"
          hx-swap-oob="true"
          {% if all_decided and has_accept %} onClick="document.getElementById('planner-modal-accept-application').classList.add('visible')" {% endif %}
          {% if not all_decided %}aria-disabled="true" title="Decide open positions first" {% elif not has_accept %}aria-disabled="true" title="No positions are accepted, cannot accept the application"{% endif %}>
    {% if all_decided and has_accept %}
      Create profile as {{ volunteer|positions_with_open_application_and_decision_accept|attr:"name"|method:"lower"|join_comma_and }}
    {% else %}
      Create profile
    {% endif %}
  </button>
{% endwith %}
{% include "applications/application_accept_dialog.html" with show_modal_immediately=accept_form_visible %}

src/applications/templates/applications/application_form_accept_some_positions.html
<section class="planner--card planner--card--internal">
  <h2>
    Position Specific Recommendations
    <small>This is a recommendation for your coworkers and will not yet trigger further actions.</small>
  </h2>
  <form hx-post="{% url "application_update_additional_positions" volunteer_id=volunteer.id %}"
        hx-trigger="change"
        hx-swap="none"
        class="field additional-positions">
    {% csrf_token %}
    {{ form.additional_positions.label_tag }}
    {{ form.additional_positions }}
  </form>
  {% include "applications/application_form_position_recommendations.html" %}
</section>

src/applications/templates/applications/application_form_add_comment.html
{% load tz %}
<section class="planner--card planner--card--internal" id="comments-section">
  <h2>Comments</h2>
  <form hx-post="{% url 'application_add_comment' volunteer_id=volunteer.id %}"
        hx-swap="outerHTML"
        hx-target="#comments-section"
        name="add_comment">
    {% csrf_token %}
    <textarea id="comment" name="comment" required></textarea>
    <small>please only write things about this person that you would say in public</small>
    <input type="submit" class="button button-primary" value="Submit" />
  </form>
  <div class="alert alert-danger"
       role="alert"
       id="comment-error-message"
       style="display: none">
    Something went wrong. Please try again. We've already been notified and will look into it.
  </div>
  <section id="comments">
    {% for comment in volunteer.comments.all|dictsortreversed:"date" %}
      <div class="comment-header">
        <p class="author">{{ comment.author }}</p>
        <time datetime="{{ comment.date.isoformat }}">
          {{ comment.date|date:"SHORT_DATETIME_FORMAT" }}
        </time>
      </div>
      <p class="text">{{ comment.text }}</p>
    {% empty %}
      <p id="no-comments-message">No comments yet...</p>
      <script>
        document.querySelector('form[name="add_comment"]').addEventListener(
          "htmx:afterSwap",
          () => { document.querySelector("#no-comments-message").remove(); },
          { once: true }
        );
      </script>
    {% endfor %}
    {% get_current_timezone as TIME_ZONE %}
    <small class="timezone-note">All times are in timezone {{ TIME_ZONE }}</small>
    <script>{% include "applications/application_form_add_comment.js" %}</script>
  </section>
</section>

src/applications/templates/applications/application_form_position_recommendations.html
<div id="position-recommendations" hx-swap-oob="true">
  {% for sarapplication in volunteer.sarapplication_set.open %}
    <form hx-post="{% url "application_decide_position" volunteer_id=volunteer.id %}"
          hx-trigger="change"
          hx-swap="none">
      {% csrf_token %}
      <input type="hidden"
             name="position"
             value="{{ sarapplication.position.key }}">
      <label for="position-decision-{{ sarapplication.position.key }}">{{ sarapplication.position.name }}</label>
      <select id="position-decision-{{ sarapplication.position.key }}"
              name="decision"
              style="font-family: 'Font Awesome 5 Free'">
        <option value="{{ sarapplication.Decision.NEW.value }}"
                {% if sarapplication.is_new %}selected{% endif %}>New</option>
        <option value="{{ sarapplication.Decision.IN_PROGRESS.value }}"
                {% if sarapplication.is_in_progress %}selected{% endif %}>In progress</option>
        <option value="{{ sarapplication.Decision.ACCEPT.value }}"
                {% if sarapplication.is_accepted %}selected{% endif %}>Accept</option>
        <option value="{{ sarapplication.Decision.REJECT.value }}"
                {% if sarapplication.is_rejected %}selected{% endif %}>Reject</option>
      </select>
      {% include "applications/application_form_position_form_last_updated.html" %}
    </form>
  {% endfor %}
</div>

src/applications/templates/applications/application_form_reject_dialog.html
{% extends "dialog.html" %}
{% load applications_tags %}
{% block modal_id %}planner-modal-reject-application{% endblock %}
{% block header %}
  {% if features.keep_rejected_applications %}
    Reject application?
  {% else %}
    Delete application?
  {% endif %}
{% endblock %}
{% block content %}
  <form method='post'
        action='{% url "application_reject" volunteer_id=volunteer.id %}'
        data-warn-on-leave-if-changed>
    {% csrf_token %}
    {{ block.super }}
  </form>
{% endblock %}
{% block body %}
  {% if not features.keep_rejected_applications %}
    This will <em>permanently and irreversibly</em> delete the application.
    <br />
  {% endif %}
  {{ reject_form }}
{% endblock %}
{% block buttons %}
  {% if features.keep_rejected_applications %}
    <input type="submit"
           name="reject-without-email"
           class="button gap-after"
           value="Reject without email" />
    <input type="submit"
           name="reject-with-email"
           class="button button-primary"
           value="Send & Reject" />
  {% else %}
    <input type="submit"
           name="reject-without-email"
           class="button gap-after"
           value="Delete without email" />
    <input type="submit"
           name="reject-with-email"
           class="button button-primary"
           value="Send & Delete" />
  {% endif %}
{% endblock %}

src/applications/templates/applications/application_list_rejected.html
{% extends "base.html" %}
{% load planner_common %}
{% load i18n humanize %}
{% load render_table from django_tables2 %}
{% block content %}
  <h1>{% trans "Rejected Applications" %}</h1>
  <form method="get" id="application_list_filter_form">
    <div style="display: flex;
                gap: 30px;
                align-items: center;
                flex-wrap: wrap">
      <div class="search-box" style="flex-basis: 500px;">
        <input type="text"
               name="search"
               value="{{ search }}"
               id="search"
               class="search{% if search %} hasValue{% endif %}"
               onInput="this.classList.toggle('hasValue', this.value)">
        <button type="submit" id="search_button" class="button button-primary">
          <i class="fas fa-search"></i>
        </button>
        <button alt="clear search"
                type="reset"
                onclick="document.getElementById('search').value = ''; this.form.submit()">
          {% inline_svg "vendor/material-icons/close.svg" %}
        </button>
      </div>
      <select id="position-filter"
              class="dropdown filter"
              name="position"
              onchange="this.form.submit()">
        <option value="">All Positions</option>
        {% for position in positions_without_group %}
          <option value="{{ position.key }}"
                  {% if position == selected_position %}selected{% endif %}>{{ position.name }}</option>
        {% endfor %}
        {% for group_label, positions in positions_with_group.items %}
          <optgroup label="{{ group_label }}">
            {% for position in positions %}
              <option value="{{ position.key }}"
                      {% if position == selected_position %}selected{% endif %}>{{ position.name }}</option>
            {% endfor %}
          </optgroup>
        {% endfor %}
      </select>
      <input hidden name="sort" value="{{ sort_filter }}" />
    </div>
  </form>
  <div class="table-with-tabs">
    <div class="tabs">
      <a href="{% url "application_list" %}">Open</a>
      <a href="{% url "application_list_rejected" %}" class="active">Rejected</a>
    </div>
    {% render_table table %}
  </div>
{% endblock %}

src/applications/templates/applications/application_list_table.html
{% extends "django_tables2/bootstrap4.html" %}
{% load django_tables2 %}
{% block table.tbody.row %}
  <tr {{ row.attrs.as_html }}>
    {% for column, cell in row.items %}
      {% if column.attrs.header %}
        {% include "applications/application_list_table_cell_th.html" %}
      {% else %}
        {% include "applications/application_list_table_cell_td.html" %}
      {% endif %}
    {% endfor %}
  </tr>
{% endblock table.tbody.row %}
{% block table.tbody.empty_text %}
  <tr>
    <td class="empty-table-message" colspan="{{ table.columns|length }}">{{ table.empty_text }}</td>
  </tr>
{% endblock table.tbody.empty_text %}

src/applications/templates/applications/application_list_table_cell_td.html
{% load django_tables2 %}
<td {{ column.attrs.td.as_html }}>
  {% if column.localize == None %}
    {{ cell }}
  {% else %}
    {% if column.localize %}
      {{ cell|localize }}
    {% else %}
      {{ cell|unlocalize }}
    {% endif %}
  {% endif %}
</td>

src/applications/templates/applications/application_list_table_cell_th.html
{% load django_tables2 %}
<th scope="row" {{ column.attrs.td.as_html }}>
  {% if column.localize == None %}
    {{ cell }}
  {% else %}
    {% if column.localize %}
      {{ cell|localize }}
    {% else %}
      {{ cell|unlocalize }}
    {% endif %}
  {% endif %}
</th>

src/applications/templates/applications/application_update_additional_positions_response.html
{% include "applications/application_form_position_recommendations.html" %}
{% include "applications/application_form_accept_button.html" %}